//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_width1  2
//---- indicator parameters
extern int FastEMA=9;
extern double multiplier=1;
//extern int SignalSMA=9;
//---- indicator buffers
extern bool op_cl1_Histo =true; 
extern bool cl_op_Histo  =false; 
double     MacdBuffer[];
double     SignalBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
if (op_cl1_Histo)int op_cl1_style=2;else op_cl1_style=0;
if (cl_op_Histo) int cl_op_style =2;else cl_op_style =0;
//---- drawing settings
   SetIndexStyle(0,op_cl1_style);//macd
   SetIndexStyle(1,cl_op_Histo);//sig// LINE//HISTOGRAM
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Cl1-Op-Cl ("+FastEMA+") ");
   SetIndexLabel(0,"Open-PrevClose");//MACD 
   SetIndexLabel(1,"Close-Open");//Signal
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)
      {
      MacdBuffer[i]    =(iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_OPEN,i) -iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i+1))*multiplier;
      SignalBuffer[i]  = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_OPEN,i);
      }
//---- signal line counted in the 2-nd buffer
//   for(i=0; i<limit; i++)
//      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);
//---- done
   return(0);
  }
//+------------------------------------------------------------------+